package fr.inra.pappso.FastaManager.sequence;

public class sequence {
	// attributs
	private String accession;

	private String description;

	protected String sequence;

	// constructeurs
	public sequence() {
		this.accession = null;
		this.description = null;
		this.sequence = null;
	}

	public void set_sequence(String S) {
		this.sequence = wash_sequence(S);
	}

	public void set_accession(String A) {
		this.accession = A;
	}

	public void set_description(String D) {
		if (D == null) {
			this.description = null;
		} else {
			D = D.replaceAll("<", "_");
			D = D.replaceAll(">", "_");
			this.description = D;
		}
	}

	public String get_accession() {
		return (accession);
	}

	public String get_description() {
		return (description);
	}

	public String get_sequence() {
		return (sequence);
	}

	public String get_fasta() {
		String fasta = ">" + accession + " " + description + "\n";
		for (int i = 0; i < sequence.length(); i += 60) {
			if (i + 60 < sequence.length())
				fasta += sequence.substring(i, i + 60) + "\n";
			else {
				fasta += sequence.substring(i, sequence.length()) + "\n";
			}
		}
		return (fasta);
	}

	private String wash_sequence(String seq) {
		// seq = seq.replaceAll("\\s+", "");
		return (seq);
	}
}
