package fr.inra.pappso.FastaManager.sequence_transforme;

import fr.inra.pappso.FastaManager.sequence.sequence;
import fr.inra.pappso.FastaManager.sequence.sequence_est;

public class seq_est_to_reverse_complement extends seq_transforme {
	private seq_transforme trans;

	public seq_est_to_reverse_complement() {
		this.seq_out = new sequence_est[1];
		this.trans = new seq_to_seq_est();
	}

	public sequence[] transforme(sequence S) throws Exception {
		this.seq_out = this.trans.transforme(S);
		String sequence = "";
		String seq = this.seq_out[0].get_sequence();
		for (int i = 0; i < seq.length(); i++) {
			sequence = complement(seq.substring(i, i + 1)) + sequence;
		}
		this.seq_out[0].set_sequence(sequence);
		return (this.seq_out);
	}

	private String complement(String S) {
		String AA = S;
		if (S.equalsIgnoreCase("A"))
			AA = "T";
		if (S.equalsIgnoreCase("T"))
			AA = "A";
		if (S.equalsIgnoreCase("C"))
			AA = "G";
		if (S.equalsIgnoreCase("G"))
			AA = "C";
		return (AA);
	}

	public String get_type() {
		return ("EST to reverse complement");
	}

	public String get_sequence_type() {
		return ("EST");
	}
}
